<?php


namespace Drupal\commerce_vado\Plugin\Field\FieldFormatter;


use Drupal\Core\Field\FieldDefinitionInterface;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Form\FormStateInterface;
use Drupal\commerce_product\Plugin\Field\FieldFormatter\AddToCartFormatter;

/**
 * Plugin implementation of the 'commerce_vado_group_add_to_cart' formatter.
 *
 * @FieldFormatter(
 *   id = "commerce_vado_group_add_to_cart",
 *   label = @Translation("Group add to cart form"),
 *   field_types = {
 *     "entity_reference",
 *   },
 * )
 */
class VadoGroupAddToCartFormatter extends AddToCartFormatter {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = [];
    $elements[0]['add_to_cart_form'] = [
      '#lazy_builder' => [
        'commerce_vado.lazy_builders:addToCartWithAddOnsForm', [
          $items->getEntity()->id(),
          $this->viewMode,
          $this->getSetting('combine'),
        ],
      ],
      '#create_placeholder' => TRUE,
    ];
    return $elements;
  }

}
